Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4671)
@@ -3346,120 +3247,122 @@
 !-- wall layers.
 !-- First for horizontal surfaces:
-    DO  m = 1, surf_usm_h%ns
-
-       surf_usm_h%dz_wall(nzb_wall,m) = surf_usm_h%zw(nzb_wall,m)
-       DO k = nzb_wall+1, nzt_wall
-          surf_usm_h%dz_wall(k,m) = surf_usm_h%zw(k,m) - surf_usm_h%zw(k-1,m)
+    DO  l = 0, 1
+       DO  m = 1, surf_usm_h(l)%ns
+
+          surf_usm_h(l)%dz_wall(nzb_wall,m) = surf_usm_h(l)%zw(nzb_wall,m)
+          DO k = nzb_wall+1, nzt_wall
+             surf_usm_h(l)%dz_wall(k,m) = surf_usm_h(l)%zw(k,m) - surf_usm_h(l)%zw(k-1,m)
+          ENDDO
+          surf_usm_h(l)%dz_window(nzb_wall,m) = surf_usm_h(l)%zw_window(nzb_wall,m)
+          DO  k = nzb_wall+1, nzt_wall
+             surf_usm_h(l)%dz_window(k,m) = surf_usm_h(l)%zw_window(k,m) - surf_usm_h(l)%zw_window(k-1,m)
+          ENDDO
+
+          surf_usm_h(l)%dz_wall(nzt_wall+1,m) = surf_usm_h(l)%dz_wall(nzt_wall,m)
+
+          DO k = nzb_wall, nzt_wall-1
+            surf_usm_h(l)%dz_wall_stag(k,m) = 0.5 * ( surf_usm_h(l)%dz_wall(k+1,m) +                        &
+                                                     surf_usm_h(l)%dz_wall(k,m) )
+          ENDDO
+          surf_usm_h(l)%dz_wall_stag(nzt_wall,m) = surf_usm_h(l)%dz_wall(nzt_wall,m)
+
+          surf_usm_h(l)%dz_window(nzt_wall+1,m) = surf_usm_h(l)%dz_window(nzt_wall,m)
+
+          DO  k = nzb_wall, nzt_wall-1
+             surf_usm_h(l)%dz_window_stag(k,m) = 0.5 * ( surf_usm_h(l)%dz_window(k+1,m) +                   &
+                                                      surf_usm_h(l)%dz_window(k,m) )
+          ENDDO
+          surf_usm_h(l)%dz_window_stag(nzt_wall,m) = surf_usm_h(l)%dz_window(nzt_wall,m)
+
+          IF (surf_usm_h(l)%green_type_roof(m) == 2.0_wp )  THEN
+!
+!--          Extensive green roof
+!--          Set ratio of substrate layer thickness, soil-type and LAI
+             soil_type = 3
+             surf_usm_h(l)%lai(m) = 2.0_wp
+
+             surf_usm_h(l)%zw_green(nzb_wall,m)   = 0.05_wp
+             surf_usm_h(l)%zw_green(nzb_wall+1,m) = 0.10_wp
+             surf_usm_h(l)%zw_green(nzb_wall+2,m) = 0.15_wp
+             surf_usm_h(l)%zw_green(nzb_wall+3,m) = 0.20_wp
+          ELSE
+!
+!--          Intensiv green roof
+!--          Set ratio of substrate layer thickness, soil-type and LAI
+             soil_type = 6
+             surf_usm_h(l)%lai(m) = 4.0_wp
+
+             surf_usm_h(l)%zw_green(nzb_wall,m)   = 0.05_wp
+             surf_usm_h(l)%zw_green(nzb_wall+1,m) = 0.10_wp
+             surf_usm_h(l)%zw_green(nzb_wall+2,m) = 0.40_wp
+             surf_usm_h(l)%zw_green(nzb_wall+3,m) = 0.80_wp
+          ENDIF
+
+          surf_usm_h(l)%dz_green(nzb_wall,m) = surf_usm_h(l)%zw_green(nzb_wall,m)
+          DO k = nzb_wall+1, nzt_wall
+              surf_usm_h(l)%dz_green(k,m) = surf_usm_h(l)%zw_green(k,m) - surf_usm_h(l)%zw_green(k-1,m)
+          ENDDO
+          surf_usm_h(l)%dz_green(nzt_wall+1,m) = surf_usm_h(l)%dz_green(nzt_wall,m)
+
+          DO k = nzb_wall, nzt_wall-1
+              surf_usm_h(l)%dz_green_stag(k,m) = 0.5 * ( surf_usm_h(l)%dz_green(k+1,m) +                    &
+                                                      surf_usm_h(l)%dz_green(k,m) )
+          ENDDO
+          surf_usm_h(l)%dz_green_stag(nzt_wall,m) = surf_usm_h(l)%dz_green(nzt_wall,m)
+
+         IF ( alpha_vangenuchten == 9999999.9_wp )  THEN
+            alpha_vangenuchten = soil_pars(0,soil_type)
+         ENDIF
+
+         IF ( l_vangenuchten == 9999999.9_wp )  THEN
+            l_vangenuchten = soil_pars(1,soil_type)
+         ENDIF
+
+         IF ( n_vangenuchten == 9999999.9_wp )  THEN
+            n_vangenuchten = soil_pars(2,soil_type)
+         ENDIF
+
+         IF ( hydraulic_conductivity == 9999999.9_wp )  THEN
+            hydraulic_conductivity = soil_pars(3,soil_type)
+         ENDIF
+
+         IF ( saturation_moisture == 9999999.9_wp )  THEN
+            saturation_moisture = m_soil_pars(0,soil_type)
+         ENDIF
+
+         IF ( field_capacity == 9999999.9_wp )  THEN
+            field_capacity = m_soil_pars(1,soil_type)
+         ENDIF
+
+         IF ( wilting_point == 9999999.9_wp )  THEN
+            wilting_point = m_soil_pars(2,soil_type)
+         ENDIF
+
+         IF ( residual_moisture == 9999999.9_wp )  THEN
+            residual_moisture = m_soil_pars(3,soil_type)
+         ENDIF
+
+         DO  k = nzb_wall, nzt_wall+1
+            swc_h(l)%val(k,m) = field_capacity
+            rootfr_h(l)%val(k,m) = 0.5_wp
+            surf_usm_h(l)%alpha_vg_green(m)      = alpha_vangenuchten
+            surf_usm_h(l)%l_vg_green(m)          = l_vangenuchten
+            surf_usm_h(l)%n_vg_green(m)          = n_vangenuchten
+            surf_usm_h(l)%gamma_w_green_sat(k,m) = hydraulic_conductivity
+            swc_sat_h(l)%val(k,m)                = saturation_moisture
+            fc_h(l)%val(k,m)                     = field_capacity
+            wilt_h(l)%val(k,m)                   = wilting_point
+            swc_res_h(l)%val(k,m)                = residual_moisture
+         ENDDO
+
        ENDDO
-       surf_usm_h%dz_window(nzb_wall,m) = surf_usm_h%zw_window(nzb_wall,m)
-       DO  k = nzb_wall+1, nzt_wall
-          surf_usm_h%dz_window(k,m) = surf_usm_h%zw_window(k,m) - surf_usm_h%zw_window(k-1,m)
-       ENDDO
-
-       surf_usm_h%dz_wall(nzt_wall+1,m) = surf_usm_h%dz_wall(nzt_wall,m)
-
-       DO k = nzb_wall, nzt_wall-1
-         surf_usm_h%dz_wall_stag(k,m) = 0.5 * ( surf_usm_h%dz_wall(k+1,m) +                        &
-                                                  surf_usm_h%dz_wall(k,m) )
-       ENDDO
-       surf_usm_h%dz_wall_stag(nzt_wall,m) = surf_usm_h%dz_wall(nzt_wall,m)
-
-       surf_usm_h%dz_window(nzt_wall+1,m) = surf_usm_h%dz_window(nzt_wall,m)
-
-       DO  k = nzb_wall, nzt_wall-1
-          surf_usm_h%dz_window_stag(k,m) = 0.5 * ( surf_usm_h%dz_window(k+1,m) +                   &
-                                                   surf_usm_h%dz_window(k,m) )
-       ENDDO
-       surf_usm_h%dz_window_stag(nzt_wall,m) = surf_usm_h%dz_window(nzt_wall,m)
-
-       IF (surf_usm_h%green_type_roof(m) == 2.0_wp )  THEN
-!
-!-- Extensive green roof
-!-- Set ratio of substrate layer thickness, soil-type and LAI
-          soil_type = 3
-          surf_usm_h%lai(m) = 2.0_wp
-
-          surf_usm_h%zw_green(nzb_wall,m)   = 0.05_wp
-          surf_usm_h%zw_green(nzb_wall+1,m) = 0.10_wp
-          surf_usm_h%zw_green(nzb_wall+2,m) = 0.15_wp
-          surf_usm_h%zw_green(nzb_wall+3,m) = 0.20_wp
-       ELSE
-!
-!-- Intensiv green roof
-!-- Set ratio of substrate layer thickness, soil-type and LAI
-          soil_type = 6
-          surf_usm_h%lai(m) = 4.0_wp
-
-          surf_usm_h%zw_green(nzb_wall,m)   = 0.05_wp
-          surf_usm_h%zw_green(nzb_wall+1,m) = 0.10_wp
-          surf_usm_h%zw_green(nzb_wall+2,m) = 0.40_wp
-          surf_usm_h%zw_green(nzb_wall+3,m) = 0.80_wp
-       ENDIF
-
-       surf_usm_h%dz_green(nzb_wall,m) = surf_usm_h%zw_green(nzb_wall,m)
-       DO k = nzb_wall+1, nzt_wall
-           surf_usm_h%dz_green(k,m) = surf_usm_h%zw_green(k,m) - surf_usm_h%zw_green(k-1,m)
-       ENDDO
-       surf_usm_h%dz_green(nzt_wall+1,m) = surf_usm_h%dz_green(nzt_wall,m)
-
-       DO k = nzb_wall, nzt_wall-1
-           surf_usm_h%dz_green_stag(k,m) = 0.5 * ( surf_usm_h%dz_green(k+1,m) +                    &
-                                                   surf_usm_h%dz_green(k,m) )
-       ENDDO
-       surf_usm_h%dz_green_stag(nzt_wall,m) = surf_usm_h%dz_green(nzt_wall,m)
-
-      IF ( alpha_vangenuchten == 9999999.9_wp )  THEN
-         alpha_vangenuchten = soil_pars(0,soil_type)
-      ENDIF
-
-      IF ( l_vangenuchten == 9999999.9_wp )  THEN
-         l_vangenuchten = soil_pars(1,soil_type)
-      ENDIF
-
-      IF ( n_vangenuchten == 9999999.9_wp )  THEN
-         n_vangenuchten = soil_pars(2,soil_type)
-      ENDIF
-
-      IF ( hydraulic_conductivity == 9999999.9_wp )  THEN
-         hydraulic_conductivity = soil_pars(3,soil_type)
-      ENDIF
-
-      IF ( saturation_moisture == 9999999.9_wp )  THEN
-         saturation_moisture = m_soil_pars(0,soil_type)
-      ENDIF
-
-      IF ( field_capacity == 9999999.9_wp )  THEN
-         field_capacity = m_soil_pars(1,soil_type)
-      ENDIF
-
-      IF ( wilting_point == 9999999.9_wp )  THEN
-         wilting_point = m_soil_pars(2,soil_type)
-      ENDIF
-
-      IF ( residual_moisture == 9999999.9_wp )  THEN
-         residual_moisture = m_soil_pars(3,soil_type)
-      ENDIF
-
-      DO  k = nzb_wall, nzt_wall+1
-         swc_h(k,m) = field_capacity
-         rootfr_h(k,m) = 0.5_wp
-         surf_usm_h%alpha_vg_green(m)      = alpha_vangenuchten
-         surf_usm_h%l_vg_green(m)          = l_vangenuchten
-         surf_usm_h%n_vg_green(m)          = n_vangenuchten
-         surf_usm_h%gamma_w_green_sat(k,m) = hydraulic_conductivity
-         swc_sat_h(k,m)                    = saturation_moisture
-         fc_h(k,m)                         = field_capacity
-         wilt_h(k,m)                       = wilting_point
-         swc_res_h(k,m)                    = residual_moisture
-      ENDDO
-
+
+       surf_usm_h(l)%ddz_wall        = 1.0_wp / surf_usm_h(l)%dz_wall
+       surf_usm_h(l)%ddz_wall_stag   = 1.0_wp / surf_usm_h(l)%dz_wall_stag
+       surf_usm_h(l)%ddz_window      = 1.0_wp / surf_usm_h(l)%dz_window
+       surf_usm_h(l)%ddz_window_stag = 1.0_wp / surf_usm_h(l)%dz_window_stag
+       surf_usm_h(l)%ddz_green       = 1.0_wp / surf_usm_h(l)%dz_green
+       surf_usm_h(l)%ddz_green_stag  = 1.0_wp / surf_usm_h(l)%dz_green_stag
     ENDDO
-
-    surf_usm_h%ddz_wall        = 1.0_wp / surf_usm_h%dz_wall
-    surf_usm_h%ddz_wall_stag   = 1.0_wp / surf_usm_h%dz_wall_stag
-    surf_usm_h%ddz_window      = 1.0_wp / surf_usm_h%dz_window
-    surf_usm_h%ddz_window_stag = 1.0_wp / surf_usm_h%dz_window_stag
-    surf_usm_h%ddz_green       = 1.0_wp / surf_usm_h%dz_green
-    surf_usm_h%ddz_green_stag  = 1.0_wp / surf_usm_h%dz_green_stag
 !
 !-- For vertical surfaces
@@ -3512,7 +3415,7 @@
 
 
-    IF ( debug_output )  CALL debug_message( 'usm_init_material_model', 'end' )
-
- END SUBROUTINE usm_init_material_model
+    IF ( debug_output )  CALL debug_message( 'usm_init_wall_heat_model', 'end' )
+
+ END SUBROUTINE usm_init_wall_heat_model
 
 
@@ -3601,5 +3504,7 @@
 !-- from file, if available. This flag is later used to control initialization of surface attributes.
 !-- Todo: for the moment disable initialization of building roofs with ground-floor-level properties.
-    surf_usm_h%ground_level = .FALSE.
+    DO  l = 0, 1
+      surf_usm_h(l)%ground_level = .FALSE.
+    ENDDO
 
     DO  l = 0, 3
@@ -3640,8 +3545,10 @@
 !
 !-- Initialization of resistances.
-    DO  m = 1, surf_usm_h%ns
-       surf_usm_h%r_a(m)        = 50.0_wp
-       surf_usm_h%r_a_green(m)  = 50.0_wp
-       surf_usm_h%r_a_window(m) = 50.0_wp
+    DO  l = 0, 1
+       DO  m = 1, surf_usm_h(l)%ns
+          surf_usm_h(l)%r_a(m)        = 50.0_wp
+          surf_usm_h(l)%r_a_green(m)  = 50.0_wp
+          surf_usm_h(l)%r_a_window(m) = 50.0_wp
+       ENDDO
     ENDDO
     DO  l = 0, 3
@@ -3655,8 +3562,10 @@
 !
 !-- Map values onto horizontal elemements
-    DO  m = 1, surf_usm_h%ns
-       surf_usm_h%r_canopy(m)     = 200.0_wp !< canopy_resistance
-       surf_usm_h%r_canopy_min(m) = 200.0_wp !< min_canopy_resistance
-       surf_usm_h%g_d(m)          = 0.0_wp   !< canopy_resistance_coefficient
+    DO  l = 0, 1
+       DO  m = 1, surf_usm_h(l)%ns
+          surf_usm_h(l)%r_canopy(m)     = 200.0_wp !< canopy_resistance
+          surf_usm_h(l)%r_canopy_min(m) = 200.0_wp !< min_canopy_resistance
+          surf_usm_h(l)%g_d(m)          = 0.0_wp   !< canopy_resistance_coefficient
+       ENDDO
     ENDDO
 !
@@ -3674,90 +3583,91 @@
 !--  follow a 3-level approach.
 !--  Level 1 - initialization via default attributes
-     DO  m = 1, surf_usm_h%ns
-!
-!--     Now, all horizontal surfaces are roof surfaces (?)
-        surf_usm_h%isroof_surf(m)   = .TRUE.
-        surf_usm_h%surface_types(m) = roof_category         !< default category for root surface
-!
-!--     In order to distinguish between ground floor level and above-ground-floor level surfaces,
-!--     set input indices.
-
-        ind_green_frac_r = MERGE( ind_green_frac_r_gfl, ind_green_frac_r_agfl,                     &
-                                  surf_usm_h%ground_level(m) )
-        ind_lai_r        = MERGE( ind_lai_r_gfl, ind_lai_r_agfl, surf_usm_h%ground_level(m) )
-        ind_z0           = MERGE( ind_z0_gfl, ind_z0_agfl, surf_usm_h%ground_level(m) )
-        ind_z0qh         = MERGE( ind_z0qh_gfl, ind_z0qh_agfl, surf_usm_h%ground_level(m) )
-!
-!--     Store building type and its name on each surface element
-        surf_usm_h%building_type(m)      = building_type
-        surf_usm_h%building_type_name(m) = building_type_name(building_type)
-!
-!--     Initialize relatvie wall- (0), green- (1) and window (2) fractions
-        surf_usm_h%frac(m,ind_veg_wall)  = building_pars(ind_wall_frac_r,building_type)
-        surf_usm_h%frac(m,ind_pav_green) = building_pars(ind_green_frac_r,building_type)
-        surf_usm_h%frac(m,ind_wat_win)   = building_pars(ind_win_frac_r,building_type)
-        surf_usm_h%lai(m)                = building_pars(ind_lai_r,building_type)
-
-        surf_usm_h%rho_c_wall(nzb_wall,m)        = building_pars(ind_hc1_wall_r,building_type)
-        surf_usm_h%rho_c_wall(nzb_wall+1,m)      = building_pars(ind_hc1_wall_r,building_type)
-        surf_usm_h%rho_c_wall(nzb_wall+2,m)      = building_pars(ind_hc2_wall_r,building_type)
-        surf_usm_h%rho_c_wall(nzb_wall+3,m)      = building_pars(ind_hc3_wall_r,building_type)
-        surf_usm_h%lambda_h(nzb_wall,m)          = building_pars(ind_tc1_wall_r,building_type)
-        surf_usm_h%lambda_h(nzb_wall+1,m)        = building_pars(ind_tc1_wall_r,building_type)
-        surf_usm_h%lambda_h(nzb_wall+2,m)        = building_pars(ind_tc2_wall_r,building_type)
-        surf_usm_h%lambda_h(nzb_wall+3,m)        = building_pars(ind_tc3_wall_r,building_type)
-        surf_usm_h%rho_c_green(nzb_wall,m)       = rho_c_soil !building_pars(ind_hc1_wall_r,building_type)
-        surf_usm_h%rho_c_green(nzb_wall+1,m)     = rho_c_soil !building_pars(ind_hc1_wall_r,building_type)
-        surf_usm_h%rho_c_green(nzb_wall+2,m)     = rho_c_soil !building_pars(ind_hc2_wall_r,building_type)
-        surf_usm_h%rho_c_green(nzb_wall+3,m)     = rho_c_soil !building_pars(ind_hc3_wall_r,building_type)
-        surf_usm_h%lambda_h_green(nzb_wall,m)    = lambda_h_green_sm !building_pars(ind_tc1_wall_r,building_type)
-        surf_usm_h%lambda_h_green(nzb_wall+1,m)  = lambda_h_green_sm !building_pars(ind_tc1_wall_r,building_type)
-        surf_usm_h%lambda_h_green(nzb_wall+2,m)  = lambda_h_green_sm !building_pars(ind_tc2_wall_r,building_type)
-        surf_usm_h%lambda_h_green(nzb_wall+3,m)  = lambda_h_green_sm !building_pars(ind_tc3_wall_r,building_type)
-        surf_usm_h%rho_c_window(nzb_wall,m)      = building_pars(ind_hc1_win_r,building_type)
-        surf_usm_h%rho_c_window(nzb_wall+1,m)    = building_pars(ind_hc1_win_r,building_type)
-        surf_usm_h%rho_c_window(nzb_wall+2,m)    = building_pars(ind_hc2_win_r,building_type)
-        surf_usm_h%rho_c_window(nzb_wall+3,m)    = building_pars(ind_hc3_win_r,building_type)
-        surf_usm_h%lambda_h_window(nzb_wall,m)   = building_pars(ind_tc1_win_r,building_type)
-        surf_usm_h%lambda_h_window(nzb_wall+1,m) = building_pars(ind_tc1_win_r,building_type)
-        surf_usm_h%lambda_h_window(nzb_wall+2,m) = building_pars(ind_tc2_win_r,building_type)
-        surf_usm_h%lambda_h_window(nzb_wall+3,m) = building_pars(ind_tc3_win_r,building_type)
-
-        surf_usm_h%target_temp_summer(m)  = building_pars(ind_indoor_target_temp_summer,building_type)
-        surf_usm_h%target_temp_winter(m)  = building_pars(ind_indoor_target_temp_winter,building_type)
-!
-!--     Emissivity of wall-, green- and window fraction
-        surf_usm_h%emissivity(m,ind_veg_wall)  = building_pars(ind_emis_wall_r,building_type)
-        surf_usm_h%emissivity(m,ind_pav_green) = building_pars(ind_emis_green_r,building_type)
-        surf_usm_h%emissivity(m,ind_wat_win)   = building_pars(ind_emis_win_r,building_type)
-
-        surf_usm_h%transmissivity(m)           = building_pars(ind_trans_r,building_type)
-
-        surf_usm_h%z0(m)                       = building_pars(ind_z0,building_type)
-        surf_usm_h%z0h(m)                      = building_pars(ind_z0qh,building_type)
-        surf_usm_h%z0q(m)                      = building_pars(ind_z0qh,building_type)
-!
-!--     Albedo type for wall fraction, green fraction, window fraction
-        surf_usm_h%albedo_type(m,ind_veg_wall)  = INT( building_pars(ind_alb_wall_r,building_type) )
-        surf_usm_h%albedo_type(m,ind_pav_green) = INT( building_pars(ind_alb_green_r,building_type) )
-        surf_usm_h%albedo_type(m,ind_wat_win)   = INT( building_pars(ind_alb_win_r,building_type) )
-
-        surf_usm_h%zw(nzb_wall,m)         = building_pars(ind_thick_1_wall_r,building_type)
-        surf_usm_h%zw(nzb_wall+1,m)       = building_pars(ind_thick_2_wall_r,building_type)
-        surf_usm_h%zw(nzb_wall+2,m)       = building_pars(ind_thick_3_wall_r,building_type)
-        surf_usm_h%zw(nzb_wall+3,m)       = building_pars(ind_thick_4_wall_r,building_type)
-
-        surf_usm_h%zw_green(nzb_wall,m)         = building_pars(ind_thick_1_wall_r,building_type)
-        surf_usm_h%zw_green(nzb_wall+1,m)       = building_pars(ind_thick_2_wall_r,building_type)
-        surf_usm_h%zw_green(nzb_wall+2,m)       = building_pars(ind_thick_3_wall_r,building_type)
-        surf_usm_h%zw_green(nzb_wall+3,m)       = building_pars(ind_thick_4_wall_r,building_type)
-
-        surf_usm_h%zw_window(nzb_wall,m)         = building_pars(ind_thick_1_win_r,building_type)
-        surf_usm_h%zw_window(nzb_wall+1,m)       = building_pars(ind_thick_2_win_r,building_type)
-        surf_usm_h%zw_window(nzb_wall+2,m)       = building_pars(ind_thick_3_win_r,building_type)
-        surf_usm_h%zw_window(nzb_wall+3,m)       = building_pars(ind_thick_4_win_r,building_type)
-
-        surf_usm_h%green_type_roof(m)     = building_pars(ind_green_type_roof,building_type)
-
+     DO  l = 0, 1
+        DO  m = 1, surf_usm_h(l)%ns
+!
+!--        Now, all horizontal surfaces are roof surfaces (?)
+           surf_usm_h(l)%isroof_surf(m)   = .TRUE.
+           surf_usm_h(l)%surface_types(m) = roof_category         !< default category for root surface
+!
+!--        In order to distinguish between ground floor level and above-ground-floor level surfaces,
+!--        set input indices.
+
+           ind_green_frac_r = MERGE( ind_green_frac_r_gfl, ind_green_frac_r_agfl,                     &
+                                     surf_usm_h(l)%ground_level(m) )
+           ind_lai_r        = MERGE( ind_lai_r_gfl, ind_lai_r_agfl, surf_usm_h(l)%ground_level(m) )
+           ind_z0           = MERGE( ind_z0_gfl, ind_z0_agfl, surf_usm_h(l)%ground_level(m) )
+           ind_z0qh         = MERGE( ind_z0qh_gfl, ind_z0qh_agfl, surf_usm_h(l)%ground_level(m) )
+!
+!--        Store building type and its name on each surface element
+           surf_usm_h(l)%building_type(m)      = building_type
+           surf_usm_h(l)%building_type_name(m) = building_type_name(building_type)
+!
+!--        Initialize relatvie wall- (0), green- (1) and window (2) fractions
+           surf_usm_h(l)%frac(m,ind_veg_wall)  = building_pars(ind_wall_frac_r,building_type)
+           surf_usm_h(l)%frac(m,ind_pav_green) = building_pars(ind_green_frac_r,building_type)
+           surf_usm_h(l)%frac(m,ind_wat_win)   = building_pars(ind_win_frac_r,building_type)
+           surf_usm_h(l)%lai(m)                = building_pars(ind_lai_r,building_type)
+
+           surf_usm_h(l)%rho_c_wall(nzb_wall,m)        = building_pars(ind_hc1_wall_r,building_type)
+           surf_usm_h(l)%rho_c_wall(nzb_wall+1,m)      = building_pars(ind_hc1_wall_r,building_type)
+           surf_usm_h(l)%rho_c_wall(nzb_wall+2,m)      = building_pars(ind_hc2_wall_r,building_type)
+           surf_usm_h(l)%rho_c_wall(nzb_wall+3,m)      = building_pars(ind_hc3_wall_r,building_type)
+           surf_usm_h(l)%lambda_h(nzb_wall,m)          = building_pars(ind_tc1_wall_r,building_type)
+           surf_usm_h(l)%lambda_h(nzb_wall+1,m)        = building_pars(ind_tc1_wall_r,building_type)
+           surf_usm_h(l)%lambda_h(nzb_wall+2,m)        = building_pars(ind_tc2_wall_r,building_type)
+           surf_usm_h(l)%lambda_h(nzb_wall+3,m)        = building_pars(ind_tc3_wall_r,building_type)
+           surf_usm_h(l)%rho_c_green(nzb_wall,m)       = rho_c_soil !building_pars(ind_hc1_wall_r,building_type)
+           surf_usm_h(l)%rho_c_green(nzb_wall+1,m)     = rho_c_soil !building_pars(ind_hc1_wall_r,building_type)
+           surf_usm_h(l)%rho_c_green(nzb_wall+2,m)     = rho_c_soil !building_pars(ind_hc2_wall_r,building_type)
+           surf_usm_h(l)%rho_c_green(nzb_wall+3,m)     = rho_c_soil !building_pars(ind_hc3_wall_r,building_type)
+           surf_usm_h(l)%lambda_h_green(nzb_wall,m)    = lambda_h_green_sm !building_pars(ind_tc1_wall_r,building_type)
+           surf_usm_h(l)%lambda_h_green(nzb_wall+1,m)  = lambda_h_green_sm !building_pars(ind_tc1_wall_r,building_type)
+           surf_usm_h(l)%lambda_h_green(nzb_wall+2,m)  = lambda_h_green_sm !building_pars(ind_tc2_wall_r,building_type)
+           surf_usm_h(l)%lambda_h_green(nzb_wall+3,m)  = lambda_h_green_sm !building_pars(ind_tc3_wall_r,building_type)
+           surf_usm_h(l)%rho_c_window(nzb_wall,m)      = building_pars(ind_hc1_win_r,building_type)
+           surf_usm_h(l)%rho_c_window(nzb_wall+1,m)    = building_pars(ind_hc1_win_r,building_type)
+           surf_usm_h(l)%rho_c_window(nzb_wall+2,m)    = building_pars(ind_hc2_win_r,building_type)
+           surf_usm_h(l)%rho_c_window(nzb_wall+3,m)    = building_pars(ind_hc3_win_r,building_type)
+           surf_usm_h(l)%lambda_h_window(nzb_wall,m)   = building_pars(ind_tc1_win_r,building_type)
+           surf_usm_h(l)%lambda_h_window(nzb_wall+1,m) = building_pars(ind_tc1_win_r,building_type)
+           surf_usm_h(l)%lambda_h_window(nzb_wall+2,m) = building_pars(ind_tc2_win_r,building_type)
+           surf_usm_h(l)%lambda_h_window(nzb_wall+3,m) = building_pars(ind_tc3_win_r,building_type)
+
+           surf_usm_h(l)%target_temp_summer(m)  = building_pars(ind_indoor_target_temp_summer,building_type)
+           surf_usm_h(l)%target_temp_winter(m)  = building_pars(ind_indoor_target_temp_winter,building_type)
+!
+!--        Emissivity of wall-, green- and window fraction
+           surf_usm_h(l)%emissivity(m,ind_veg_wall)  = building_pars(ind_emis_wall_r,building_type)
+           surf_usm_h(l)%emissivity(m,ind_pav_green) = building_pars(ind_emis_green_r,building_type)
+           surf_usm_h(l)%emissivity(m,ind_wat_win)   = building_pars(ind_emis_win_r,building_type)
+
+           surf_usm_h(l)%transmissivity(m)           = building_pars(ind_trans_r,building_type)
+
+           surf_usm_h(l)%z0(m)                       = building_pars(ind_z0,building_type)
+           surf_usm_h(l)%z0h(m)                      = building_pars(ind_z0qh,building_type)
+           surf_usm_h(l)%z0q(m)                      = building_pars(ind_z0qh,building_type)
+!
+!--        Albedo type for wall fraction, green fraction, window fraction
+           surf_usm_h(l)%albedo_type(m,ind_veg_wall)  = INT( building_pars(ind_alb_wall_r,building_type) )
+           surf_usm_h(l)%albedo_type(m,ind_pav_green) = INT( building_pars(ind_alb_green_r,building_type) )
+           surf_usm_h(l)%albedo_type(m,ind_wat_win)   = INT( building_pars(ind_alb_win_r,building_type) )
+
+           surf_usm_h(l)%zw(nzb_wall,m)         = building_pars(ind_thick_1_wall_r,building_type)
+           surf_usm_h(l)%zw(nzb_wall+1,m)       = building_pars(ind_thick_2_wall_r,building_type)
+           surf_usm_h(l)%zw(nzb_wall+2,m)       = building_pars(ind_thick_3_wall_r,building_type)
+           surf_usm_h(l)%zw(nzb_wall+3,m)       = building_pars(ind_thick_4_wall_r,building_type)
+
+           surf_usm_h(l)%zw_green(nzb_wall,m)         = building_pars(ind_thick_1_wall_r,building_type)
+           surf_usm_h(l)%zw_green(nzb_wall+1,m)       = building_pars(ind_thick_2_wall_r,building_type)
+           surf_usm_h(l)%zw_green(nzb_wall+2,m)       = building_pars(ind_thick_3_wall_r,building_type)
+           surf_usm_h(l)%zw_green(nzb_wall+3,m)       = building_pars(ind_thick_4_wall_r,building_type)
+
+           surf_usm_h(l)%zw_window(nzb_wall,m)         = building_pars(ind_thick_1_win_r,building_type)
+           surf_usm_h(l)%zw_window(nzb_wall+1,m)       = building_pars(ind_thick_2_win_r,building_type)
+           surf_usm_h(l)%zw_window(nzb_wall+2,m)       = building_pars(ind_thick_3_win_r,building_type)
+           surf_usm_h(l)%zw_window(nzb_wall+3,m)       = building_pars(ind_thick_4_win_r,building_type)
+
+           surf_usm_h(l)%green_type_roof(m)     = building_pars(ind_green_type_roof,building_type)
+        ENDDO
      ENDDO
 
